﻿Imports System.Windows.Forms
Imports System.Drawing
Module Module1
    Dim fileName As String '読み込むファイル名
    Dim r As String '入力された値(使いまわし)
    Dim w As Integer '生産する画像の横幅
    Dim h As Integer '生産する画像の縦幅
    Dim fileType As String '生産する画像のファイル形式
    Dim Bm As Bitmap
    Dim ft As String '生産する画像のファイル形式(確認でのみ使用)

    Sub Main()
        Console.Title = "テクスチャピクチャ ver 0.3"

        Console.WriteLine("++++++++++++++++++++++++++++++++++++")
        Console.WriteLine("+++++++☆テクスチャピクチャ☆+++++++")
        Console.WriteLine("++++++++++++++++++++++++++++++++++++")
        Console.WriteLine("")
        Console.WriteLine("ver 0.3")
        Console.WriteLine("")
        System.Threading.Thread.Sleep(500)
        Console.WriteLine(">画像ファイルのテクスチャで画像ファイルを作成します")
        Console.WriteLine("")

        Do
            If Microsoft.VisualBasic.Command = "" Then
                Console.WriteLine(">テクスチャに使う画像ファイルを入力してください。")
                Console.WriteLine(">※[f]でファイルダイアログ参照。")
                Console.WriteLine("※[v]でクリップボードから入力。(入力された後から追加で入力(?)できます。ファイルの場所などをコピーしておいてください。)")
                Console.WriteLine(">※使用できるファイル形式(.bmp/.png/.jpg/.gif)")
                Do

                    fileName = Console.ReadLine()

                    If fileName = "f" Then
                        'OpenFileDialogクラスのインスタンスを作成
                        Dim ofd As New OpenFileDialog()

                        '[ファイルの種類]に表示される選択肢を指定する
                        '指定しないとすべてのファイルが表示される
                        ofd.Filter = _
                            "画像ファイル(*.bmp;*.png;*.jpg;*.gif)|*.bmp;*.png;*.jpg;*.gif|すべてのファイル(*.*)|*.*"
                        '[ファイルの種類]ではじめに
                        '「すべてのファイル」が選択されているようにする
                        ofd.FilterIndex = 2
                        'タイトルを設定する
                        ofd.Title = "開くファイルを選択してください"
                        'ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
                        ofd.RestoreDirectory = True
                        '存在しないファイルの名前が指定されたとき警告を表示する
                        'デフォルトでTrueなので指定する必要はない
                        ofd.CheckFileExists = True
                        '存在しないパスが指定されたとき警告を表示する
                        'デフォルトでTrueなので指定する必要はない
                        ofd.CheckPathExists = True

                        'ダイアログを表示する
                        If ofd.ShowDialog() = DialogResult.OK Then
                            'OKボタンがクリックされたとき
                            '選択されたファイル名を表示する
                            Console.WriteLine(ofd.FileName)
                            fileName = ofd.FileName
                        End If

                    ElseIf fileName = "v" Then 'クリップボードの内容を入力
                        Console.Write(Clipboard.GetData(DataFormats.Text))
                        fileName = Clipboard.GetData(DataFormats.Text) & Console.ReadLine()
                    End If

                    System.Threading.Thread.Sleep(500)
                    Console.WriteLine(">ファイル確認中…")

                    '指定したファイルが存在するか確認
                    If IO.File.Exists(fileName) Then
                        '指定したファイルが画像ファイルか確認

                        Dim oFile As New IO.FileInfo(fileName)

                        If oFile.Extension = ".bmp" OrElse oFile.Extension = ".jpg" OrElse oFile.Extension = ".png" OrElse oFile.Extension = ".gif" Then
                            Exit Do
                        Else
                            Console.WriteLine("")
                            Console.WriteLine(">ファイル形式が対応していません…")
                            Console.WriteLine(">もう一度入力してください。")
                        End If
                    Else
                        Console.WriteLine("")
                        Console.WriteLine(">ファイルが存在しません…")
                        Console.WriteLine(">もう一度入力してください。")
                    End If

                Loop

            Else 'ファイルがドラッグされていたら
                Try
                    Console.WriteLine(Microsoft.VisualBasic.Command)
                    fileName = Microsoft.VisualBasic.Command
                    System.Threading.Thread.Sleep(500)
                    Console.WriteLine(">ファイル確認中…")

                    Dim oFile As New IO.FileInfo(fileName)

                    If oFile.Extension = ".bmp" OrElse oFile.Extension = ".jpg" OrElse oFile.Extension = ".png" OrElse oFile.Extension = ".gif" Then

                    Else
                        Console.WriteLine("")
                        Console.WriteLine(">ファイル形式が対応していません…")
                        Console.WriteLine(">アプリケーションを終了します。Enterキーを押してください。")
                        Console.ReadLine()
                        End

                    End If
                Catch ex As Exception
                    Console.WriteLine(ex.Message)
                    Console.WriteLine("エラーが発生しました…")
                    Console.WriteLine(">アプリケーションを終了します。Enterキーを押してください。")
                    Console.ReadLine()
                    End
                End Try

            End If

            System.Threading.Thread.Sleep(500)
            Console.WriteLine("")
            Console.WriteLine(">ファイルを確認しました!")
            Console.WriteLine("")
            System.Threading.Thread.Sleep(300)
            Console.WriteLine("****************************************************")
            Console.WriteLine(">生産する画像の設定に移ります。")
            System.Threading.Thread.Sleep(100)


            Console.WriteLine(">生産する画像の横幅を指定してください。")
            Console.WriteLine(">※少数不可")
            Do
                Try 'エラーが発生したら入力が不適切と判断
                    r = Console.ReadLine()
                    w = Integer.Parse(r) '文字列を整数に変換
                    Exit Do
                Catch ex As Exception
                    Console.WriteLine(ex.Message)
                End Try
                Console.WriteLine("")
                Console.WriteLine(">数値が正しくないようです")
                Console.WriteLine(">もう一度入力してください。")
            Loop

            System.Threading.Thread.Sleep(100)
            Console.WriteLine("")
            Console.WriteLine(">生産する画像の縦幅を指定してください。")
            Console.WriteLine(">※少数不可")
            Do
                Try
                    r = Console.ReadLine()
                    h = Integer.Parse(r) '文字列を整数に変換
                    Exit Do
                Catch ex As Exception
                    Console.WriteLine(ex.Message)
                End Try
                Console.WriteLine("")
                Console.WriteLine(">数値が正しくないようです")
                Console.WriteLine(">もう一度入力してください。")
            Loop
            System.Threading.Thread.Sleep(100)
            Console.WriteLine("")
            Console.WriteLine(">生産する画像のファイル形式を指定してください")
            Console.WriteLine(">※Bitmap→[b] png→[p] jpeg→[j] gif→[g]")

            Do
                r = Console.ReadLine

                If r = "b" OrElse r = "p" OrElse r = "j" OrElse r = "g" Then
                    fileType = r
                    Exit Do
                End If

                Console.WriteLine("")
                Console.WriteLine(">入力が正しくないようです")
                Console.WriteLine(">もう一度入力してください。")
            Loop



            Select Case fileType
                Case "b"
                    ft = "Bitmap"
                Case "p"
                    ft = "PNG"
                Case "j"
                    ft = "JPEG"
                Case "g"
                    ft = "GIF"
            End Select

            Console.WriteLine("")
            Console.WriteLine(">設定内容を確認します。")
            System.Threading.Thread.Sleep(200)
            Console.WriteLine("")
            Console.WriteLine("-----------------------------------------------")
            Console.WriteLine("元の画像:" & fileName)
            Console.WriteLine("生産する画像の横幅:" & w)
            Console.WriteLine("生産する画像の縦幅:" & h)
            Console.WriteLine("生産する画像のファイル形式:" & ft)
            Console.WriteLine("-----------------------------------------------")
            Console.WriteLine("")
            System.Threading.Thread.Sleep(200)
            Console.WriteLine(">以上の内容でよろしいですか(y/n)")
            Do
                r = Console.ReadLine
            Loop Until r = "y" OrElse r = "n"
            If r = "y" Then
                Exit Do
            ElseIf r = "n" Then
                Console.WriteLine(">もう一度設定しなおします。")
            End If
        Loop

        System.Threading.Thread.Sleep(200)
        Console.WriteLine(">お疲れ様でした!")
        Console.WriteLine(">これから画像を生産します。")
        Console.WriteLine("")
        System.Threading.Thread.Sleep(200)

        Try

            Bm = New Bitmap(w, h)
            Dim g As Graphics = Graphics.FromImage(Bm) 'Bitmapクラスを渡してGrapgicsを取得
            Dim b As New TextureBrush(Image.FromFile(fileName)) '画像でテクスチャするブラシを作成

            g.FillRectangle(b, 0, 0, w, h) '描画

            Console.WriteLine(">描画完了")
            System.Threading.Thread.Sleep(200)

            Select Case fileType 'ファイル形式別に保存
                Case "b"
                    Bm.Save("texturePic.bmp", Imaging.ImageFormat.Bmp)
                Case "p"
                    Bm.Save("texturePic.png", Imaging.ImageFormat.Png)
                Case "j"
                    Bm.Save("texturePic.jpg", Imaging.ImageFormat.Jpeg)
                Case "g"
                    Bm.Save("texturePic.gif", Imaging.ImageFormat.Gif)
            End Select

            Console.WriteLine(">保存完了")
            System.Threading.Thread.Sleep(200)
            Console.WriteLine(">無事、ファイルを生産できました!")
            Console.WriteLine(">アプリケーションの下の[texturePic]という名前の画像ファイルを確認してください。")
            Console.WriteLine("")
            System.Threading.Thread.Sleep(200)
            Console.WriteLine("ご利用ありがとうございました<m(__)m>")
            Console.ReadLine()
            Application.Exit()
        Catch ex As Exception
            Console.WriteLine()
            Console.WriteLine(ex.Message)
            Console.WriteLine("エラーが発生しました…")
            Console.WriteLine(">アプリケーションを終了します。Enterキーを押してください。")
            Console.ReadLine()
        End Try





    End Sub

End Module
